﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Lesson14
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        string ReadPage(WebClient client, string uri)
        {
            try
            {
                using (var text = new StreamReader(client.OpenRead(uri)))
                {
                    return text.ReadToEnd();
                }
            }
            catch (WebException e)
            {
                return e.Message;
            }
        }

        string GetCsharpUri(string html)
        {
            var anchorTextPosition = html.IndexOf("C#</a>");
            if (anchorTextPosition < 0) return string.Empty;
            var hrefPosition = html.LastIndexOf(@"href=""", anchorTextPosition);
            if (hrefPosition < 0) return string.Empty;
            hrefPosition += 6;
            var uriEndPosition = html.IndexOf('"', hrefPosition);
            if (uriEndPosition < 0) return string.Empty;
            var uri = html.Substring(hrefPosition, uriEndPosition - hrefPosition);
            if (uri.Contains("http://")) return uri;
            return ((uri[0] == '/') ? "http://codezine.jp" : "http://codezine.jp/") + uri;
        }

        string CreateIndex(string html)
        {
            var builder = new StringBuilder("<html><body><ul>");
            var regex = new Regex(@"(<a\s+)(href=""(/article/detail/[^""]+"">[^<]+</a>))");
            foreach (Match match in regex.Matches(html))
            {
                builder.Append("<li>").Append(match.Groups[1].Value).Append(@"target=""_blank"" ");
                if (match.Groups[3].Value.Contains("http://"))
                {
                    builder.Append(match.Groups[1].Value);
                }
                else
                {
                    builder.Append(html.Substring(match.Groups[2].Index, 
                                   match.Groups[3].Index - match.Groups[2].Index))
                           .Append("http://codezine.jp");
                    if (match.Groups[3].Value[0] != '/')
                    {
                        builder.Append('/');
                    }
                    builder.Append(html.Substring(match.Groups[3].Index, match.Groups[3].Length));
                }
                builder.AppendLine("</li>");
            }
            builder.Append("</ul></body></html>");
            return builder.ToString();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            using (var client = new WebClient())
            {
                client.Headers.Add(HttpRequestHeader.UserAgent, "MyUserAgent");
                var uri = GetCsharpUri(ReadPage(client, "http://codezine.jp/"));
                if (string.IsNullOrEmpty(uri))
                {
                    MessageBox.Show("読み込み失敗");
                    return;
                }
                webBrowser1.DocumentText = CreateIndex(ReadPage(client, uri));
            }
        }
    }
}
